#ifdef FORMS

#include "defs.h"

#define LONG_STAR_STRING "********************************************************************************"
#define LONG_SPACE_STRING "                                                                                "

int change_form_link ARGS2(struct link *, form_link, int, mode)
{

    int type= form_link->tx;
    char newstring[120];
    int inum;
    char *tmptr;
    BOOLEAN repaint=FALSE;
    char print_arg[12];
    int str_len;

    /* move to the link position */
    move(form_link->ly, form_link->lx);

    switch(type) {
	case BOOLEAN_TYPE:
	    if(form_link->cur_value) {
		form_link->hightext[1] = ' ';
		form_link->cur_value = 0;
	    } else {
		form_link->hightext[1] = '*';
		form_link->cur_value = 1;
	    }
	    
		/* add the new info */
	    addstr(form_link->hightext);
	    break;
	case STRING_TYPE:
	    form_getstr(form_link->hightext, STRING_TYPE);
	    break;
	case PASSWORD_TYPE:
	    /* we hide the password info in the taddr field so it
	     * doesnt get displayed
	     */
	    str_len = form_getstr(form_link->taddr,PASSWORD_TYPE);
	    mystrncpy(form_link->hightext,LONG_SPACE_STRING, 
						strlen(form_link->hightext));
            strncpy(form_link->hightext,LONG_STAR_STRING, str_len);
	    break;
	case INT_TYPE:
		/* make a width string so that we can maintain the width */
	    sprintf(print_arg,"%%-%dd",strlen(form_link->hightext));
	    sprintf(newstring, print_arg, form_link->cur_value);
	    form_getstr(newstring, INT_TYPE);

	    /* kill spaces at the beginning */
	    tmptr = newstring;
	    while(*tmptr==' ') tmptr++;

	    inum = atoi(tmptr);
	    if(inum < form_link->lrange || inum > form_link->hrange) {
		sprintf(newstring,"Integer value must be between %d and %d",
			form_link->lrange, form_link->hrange);
		statusline(newstring);
	    } else {
	        sprintf(form_link->hightext, print_arg, inum);
		form_link->cur_value = inum;
	    }
	    break;
	case MONTH_TYPE:
	case DATE_MONTH_TYPE:
	    if(mode==FORM_UP) {
		if(form_link->cur_value < 11)
		    form_link->cur_value++;
		else
		    form_link->cur_value = 0;
	    } else {
		if(form_link->cur_value > 0)
		    form_link->cur_value--;
		else
		    form_link->cur_value = 11;
	    }

	    strcpy(form_link->hightext,month_strings[form_link->cur_value]);
	    addstr(form_link->hightext);
	    break;
	case DATE_MDAY_TYPE:
	case MDAY_TYPE:
	    if(mode==FORM_UP) {
		if(form_link->cur_value < 31)
		    form_link->cur_value++;
		else
		    form_link->cur_value = 1;
	    } else {
		if(form_link->cur_value > 1)
		    form_link->cur_value--;
		else
		    form_link->cur_value = 31;
	    }

	    sprintf(form_link->hightext,"%2d",form_link->cur_value);
	    addstr(form_link->hightext);
	    break;
	case DATE_YEAR_TYPE:
	case YEAR_TYPE:
	    if(mode==FORM_UP) {
		if(form_link->cur_value < 2000)
		    form_link->cur_value++;
		else
		    form_link->cur_value = 1970;
	    } else {
		if(form_link->cur_value > 1970)
		    form_link->cur_value--;
		else
		    form_link->cur_value = 2000;
	    }

	    sprintf(form_link->hightext,"%4d",form_link->cur_value);
	    addstr(form_link->hightext);
	    break;
    }

    return(repaint);

} 
	    
#endif FORMS
