#include "defs.h"

/*
 *  in edit mode invoke either emacs or vi or the default editor
 *  to display and edit the current file
 *  Both vi and emacs will open the file to the same line that the
 *  screen cursor is on when editing is invoked
 */

PUBLIC void edit_current_file ARGS5(char *,startdir, char *,newfile, 
					char *,origdir, int,cur, int,lineno)
{

	char command[90];

#ifndef VMS
	if(strstr(editor,"emacs") || strstr(editor,"vi")) {
	   if(*newfile != '/')
	   /* do command emacs or vi +# file */
	     sprintf(command,"%s +%d \"%s/%s\"", editor, lineno+links[cur].ly, 
		     startdir, newfile);
	   else
	     sprintf(command,"%s +%d \"%s\"",editor, lineno+links[cur].ly, 
								newfile);
	} else {
	    if(*newfile != '/')
	       sprintf(command,"%s \"%s/%s\"",editor, startdir, newfile);
	    else
	       sprintf(command,"%s \"%s\"",editor, newfile);
	}
#else /* VMS */
	   /* if no device or directory is in the path, prefix startdir */
	   if (strchr(newfile,':') == 0 && strchr(newfile,']' == 0) &&
							strcmp(startdir,"."))
	       sprintf(command,"%s %s%s",editor, startdir, newfile);
	   else {
	       if (strncmp(newfile,"./",2) == 0)
	           sprintf(command,"%s %s",editor, newfile+2);
	       else
	           sprintf(command,"%s %s",editor, newfile);
	   }
#endif /* VMS */

	stop_curses();
	chdir(origdir);
	signal(SIGINT, SIG_IGN);
	system(command);
	signal(SIGINT, cleanup_sig);
	chdir(startdir);
	start_curses();
}
