#include "defs.h"

/*
 *  I stole this from the gopher people
 *
** Non System V getstr's all seem to be broken in some way.  Anyways
** a normal getstr wouldn't do for us.  This one displays a current value
** That the user can edit.
**
** Also, if a non-printable character is pressed we stop and return it.
** (tab, esc etc. )
 *
 * VERY IMPORTANT  this procedure will not reduce or increase
 *		   the length of the string passed to it
 *		   it will only modify within the string
*/
PUBLIC int form_getstr ARGS2(char *,inputline, int,type)
{
     int pointer = 0;
     int ch;
     int last_char;
     int str_size = strlen(inputline);

     /* find that last char in the string that is non-space */
     last_char = strlen(inputline)-1;
     while(isspace(inputline[last_char])) last_char--; 

     /*** Check to see if there's something in the inputline already ***/
     
     while (pointer <= last_char) {
	  if(type == PASSWORD_TYPE)
	     addch('*');
	  else
	     addch(inputline[pointer]);
	  pointer ++;
     }
     refresh();
	  

     for (;;) {
	  ch = mygetch();

	  switch (ch) {

#ifdef AIX
          case '\227':
#endif
	  case '\n':
	  case '\r':
	  case '\t':
	  case UPARROW:  /* up and down arrows count as return */
	  case DNARROW:
	       return(pointer);  /* return the length of the string */
	       break;

	  /**  Backspace and delete **/

	  case '\010':
	  case '\177':
	  case LTARROW:
	       if (pointer > 0) {
		    addch('\010');
		    addch(' ');
		    addch('\010');
	       
		    inputline[--pointer] = ' ';
		    refresh();
	       }
	       break;
		    
	       
	  default:
	       if (isprint(ch)) {
		    if(pointer < str_size) {
		        inputline[pointer++]= ch;
			if(type == PASSWORD_TYPE)
			    addch('*');
			else
		            addch(ch);
		        refresh();
		    } 
	       }
		/* just ignore unprintable charactors */
	  }
     }

}
