#include "gopher.h"

/**
*** Show file takes an open socket connection, writes it to a file
*** and passes it to your favorite pager.
**/
/* global variable used to abort gopher transfer using async i/o */
BOOLEAN abort_gopher_transfer = FALSE;

#define BIG_LINE "-------------------------------------------------------\n"

PUBLIC int get_file ARGS6(GopherStruct *,ZeGopher, char *,newfile, 
		char *,gopher_info, char *,search_string, 
		BOOLEAN,form_submit, FILE *,current_fp)
{
     int i, sockfd, iLength, itmp, lineno=0;
     FILE *tmpfile;
     char inputline[513];
     char tmpline[256];
     int screen_count=0, no_more_defines=TRUE;
     char *second_colon;
     char *single_line, *end_of_line;
     struct chunck_struct * data_ptr;

     nlinks = 0; /* set nlinks to zero because of a new page */
     more = FALSE;
     abort_gopher_transfer=FALSE;

    /* set defaults */   
    *base1 = '\0';
    *owner = '\0';
    *owner_info = '\0';
    *owner_address = '\0';
    delimiter.end_link = '>';
    strcpy(delimiter.target, LEFT_TARGET_DELIMITER);
    strcpy(delimiter.end_target, RIGHT_TARGET_DELIMITER);
    delimiter.token = ':';
    if(GSgetType(ZeGopher)==A_INDEX || GSgetType(ZeGopher)==A_DIRECTORY)
    	delimiter.link = '<';
    else
	delimiter.link = DEFAULT_LINK_DELIMITER;

    if(GSgetType(ZeGopher) == A_FILE) 
	no_more_defines=FALSE;

    /* reset the socket buffer to make sure there is no junk in the
     * buffer when we start
     */
     initialize_sockbuff();

/* set up an async way of aborting the gopher transfer */
#ifdef HAVE_SIGIO
     fcntl (0, F_SETOWN, getpid() );
     fcntl ( 0, F_SETFL, FASYNC );
#endif HAVE_SIGIO

#ifdef HAVE_SIGIO
     signal(SIGIO, async_io); /* */
#else
     signal(SIGINT, async_io); /* */
#endif HAVE_SIGIO

     if ((sockfd = connect_to_gopher(GSgetHost(ZeGopher), GSgetPort(ZeGopher))) <0) {
#ifdef HAVE_SIGIO
	  signal(SIGIO, SIG_IGN); /* */
#else
	  signal(SIGINT, cleanup_sig); /* */
#endif HAVE_SIGIO
	  check_sock(sockfd, GSgetHost(ZeGopher));
	  return(-1);
     }

     /** Send out the request **/
     if(GSgetType(ZeGopher) == A_INDEX) {
     	writestring(sockfd, GSgetPath(ZeGopher));
     	writestring(sockfd, "\t");
    	writestring(sockfd, search_string);
     	writestring(sockfd, "\r\n");
     } else if(form_submit) {   /* submit a form */
	write_form_links_to_sock(sockfd, current_fp);
	writestring(sockfd, ".\r\n");
     } else {
   	writestring(sockfd, GSgetPath(ZeGopher));
     	writestring(sockfd, "\r\n");
     }

     /** Open a temporary file **/

     if ((tmpfile = fopen(newfile, "w")) == NULL)
	  perror("Couldn't make a tmp file!\n"), exit(-1);

	       	    
     if(GSgetType(ZeGopher) == A_DIRECTORY || GSgetType(ZeGopher) == A_INDEX) {
		/* put the delimiter defines in */
	fprintf(tmpfile," end_link_delimiter=> \n link_delimiter=< \n");
	fprintf(tmpfile," token_delimiter=: \n");
	if(GSgetType(ZeGopher) == A_DIRECTORY)
	   sprintf(tmpline,"\t\tDirectory of %s\n",GSgetTitle(ZeGopher));
	else
	   sprintf(tmpline,"\t%s:  %s\n",GSgetTitle(ZeGopher),search_string);
    	fprintf(tmpfile, "\n%s\n", tmpline);
	/* put on the screen the same thing in the file */
	clear();
	lineno=2;
	addch('\n');
        display_a_line(tmpline, &itmp, &lineno, search_string, FALSE,
			       gopher_info, newfile, base1);
	addch('\n');
	lineno++;
	/* set up delimiter defines */
	delimiter.link = '<';
	delimiter.end_link = '>';
	delimiter.token = ':';
     }

     for(;;) {

	  if(abort_gopher_transfer==TRUE) {
#ifdef HAVE_SIGIO
		signal(SIGIO, SIG_IGN);
#else
     		signal(SIGINT, cleanup_sig);
#endif HAVE_SIGIO
	        fprintf(tmpfile,"\nThe rest of the file was aborted during transfer.\n");
		statusline("Transfer aborted!");
		sleep(1);
		break;
	  }

          iLength = readline(sockfd, inputline, 512);
          if (iLength == 0) {
	       refresh();
               break;
          }

          ZapCRLF(inputline);

	  if(lineno == 0) 
		if(strstr(inputline,"Server error:")) {
     			fclose(tmpfile);
			Socket_Close(sockfd);
			remove(newfile); /* get rid of the empty file */
#ifdef HAVE_SIGIO
			signal(SIGIO, SIG_IGN);
#else
     		        signal(SIGINT, cleanup_sig);
#endif HAVE_SIGIO

			return(-1);
		}
	  
	  /*** Ugly hack ahead..... ***/

          if (GSgetType(ZeGopher) == A_CSO) {

	       if (inputline[0] == '2') {
		    refresh();
		    break;
		}

	       if(lineno==0) {
		    clear();
	 	    sprintf(tmpline,"    	%s\n",GSgetTitle(ZeGopher));
		    addstr(tmpline);
		    fprintf(tmpfile,"%s",tmpline);
		    lineno++;
		}

	       if ((inputline[0] >= '3') && (inputline[0] <= '9'))  {
		    fprintf(tmpfile, " \n\n	%s\n", inputline+4);
		    addstr("\n\n	");
		    addstr(inputline+4);
		    addch('\n');
		    refresh();
		    break;
	       }


		/* add the lines to seperate the CSO entries */
	       if (inputline[0] == '-') {
		    /*  lines look like  -200:#: 
		     *  where # can be multiple digits
		     *  find the second colon and check the digit to the
		     *  left of it to see if they are diferent
		     *  if they are draw a line
		     */

		    second_colon = strchr( strchr(inputline,':')+1, ':');

		    if(second_colon != NULL) {

		        if (*(second_colon-1) != i) { 
			     fputs(BIG_LINE, tmpfile);
			     if(lineno < LINES-1) {
			        addstr(BIG_LINE);
	     	                lineno++;
			     }
		         }

		        i =	 *(second_colon-1) ;
    	
		        sprintf(tmpline, "%s\n", second_colon+1);
		      
		        fprintf(tmpfile,"%s",tmpline);
		        if(lineno < LINES-1) {
		            addstr(tmpline); /* write to screen */
			    lineno++;
		        } else if(lineno == LINES-1) {
	    		    statusline(GOPHER_WAIT_MESSAGE);
			    more=TRUE;
		        }
		    }  /* end if second_colon */
	       }
          } else { 
	       if ((inputline[0] == '.') && inputline[1] == '\0') {
		    refresh();
		    break;
		}
	       else {
	       	    if(GSgetType(ZeGopher) == A_DIRECTORY  || 
			GSgetType(ZeGopher) == A_INDEX)  /* */
			  /* make dirs look like links*/
			strcpy(inputline, make_dir_links(inputline, 
					GSgetType(ZeGopher), search_string));

		    fprintf(tmpfile, "%s\n", inputline);
		
	   
/*  the following code will add the first screen of text to the screen
    as the file is being downloaded, it takes the input line and puts
    it on the screen */
	if(lineno < LINES-1) {
	   if(no_more_defines == FALSE) {
	      if(defineswitch(inputline)==FALSE) {
		no_more_defines = TRUE;

		/* display a line cannot handle lines with '\n' in them
		 * therefore we will break up the line into multiple
		 * segments of a line without '\n's
		 */
		single_line = inputline;
		do {

		    if((end_of_line = strchr(single_line, '\n')) != NULL)
		       	*end_of_line = '\0';

	            display_a_line(single_line, &itmp, &lineno, search_string, 
				(*search_string == '\0' ? FALSE : TRUE),
			       gopher_info, newfile, base1);

		    lineno++;
			
		    if(lineno == LINES-1) {
			break;
		    }
		
		    single_line = end_of_line + 1;

		} while(end_of_line);

	      }
	   } else {
		/* display a line cannot handle lines with '\n' in them
		 * therefore we will break up the line into multiple
		 * segments of a line without '\n's
		 */
		single_line = inputline;
		do {
		    if((end_of_line = strchr(single_line, '\n')) != NULL)
		       	*end_of_line = '\0';

	            display_a_line(single_line, &itmp, &lineno, search_string, 
			     (*search_string == '\0' ? FALSE : TRUE),
			      gopher_info, newfile, base1);
	      
		    lineno++;

		    if(lineno == LINES-1)
			break;
		
		    single_line = end_of_line + 1;

		} while(end_of_line);
	   }

	} else if(lineno == LINES-1) {
	    statusline(GOPHER_WAIT_MESSAGE);
	    lineno++;
	    more = TRUE;
	    refresh();
	}
       } /* end of else */
      }
     } /* end for */

	/* set this just in case.  It really shouldn't be neccessary */
     if(lineno >= LINES-1) {
	more = TRUE;
     }

     fclose(tmpfile);
     Socket_Close(sockfd);

#ifdef HAVE_SIGIO
     signal(SIGIO, SIG_IGN);
#else
     signal(SIGINT, cleanup_sig);
#endif HAVE_SIGIO
     return(0);
}

PUBLIC void async_io ARGS1(int,sig)
{
#ifdef HAVE_SIGIO
	if(toupper(mygetch())=='A')  /* */
#endif HAVE_SIGIO
	  
	    abort_gopher_transfer=TRUE;  /* */
#ifdef VMS
	/* reassert the AST */
        signal(SIGINT, async_io);
	/* refresh the screen to get rid of the "cancel" message */
	/* This causes the page to be blank!!			 */
	stop_curses();
	start_curses();
#endif VMS
}
