#include "defs.h"
#include <time.h>

PUBLIC void save_form ARGS3(int,cur_line, FILE **,in_file, char *,cur_file_name)
{
    FILE *out_file;
    char *place_ptr;
    char new_value[120];
    char in_buffer[LINESIZE], temp_string[LINESIZE];
    char *link_start_ptr, *link_end_ptr;
    int link_num, old_link_num=0;
    int i;
    int init_length;
    char *init_ptr;
    struct tm time_st;

	/* change the cur_file_name to the new output file
	 * so that it gets saved in the history stack as this
	 * new file and not the old one
	 */
	/* see if we have already saved before */
	/* if so just toggle the first digit to make another file */
    if((place_ptr = strstr(cur_file_name,"LYNXform")) != NULL) {
	if(*(place_ptr-1) == '1')
	   *(place_ptr-1) = '2';
	else
	   *(place_ptr-1) = '1';
    } else {  /* make a new name */
	sprintf(cur_file_name,"%s1LYNXform%d%d",TEMP_SPACE, getpid(), nhist);
    }

    if((out_file = fopen(cur_file_name,"w")) == NULL) {
	statusline("FORM ERROR - Can't Save Form - Please exit this form");
	sleep(3);
	return;
    }

    /* rewind the form and advance to the current line */
    rewind(*in_file);

    /* go past the defines at the top - there is at least one */
    while(fgets(in_buffer, LINESIZE, *in_file) && defineswitch(in_buffer)) {
	fputs(in_buffer, out_file);  /* write it out to the file */
	fputc('\n',out_file);   /* defineswitch strips returns */
    }

    strcat(in_buffer,"\n");  /* add the return that defineswitch stripped */

	/* if cur_line is > 1 then we need to advance through the
	   file a bit 
	 */
    if(cur_line > 1) { /* save out the line in the line buffer */
	fputs(in_buffer, out_file);  /* write it out to the file */

        for(i=2; fgets(in_buffer, LINESIZE, *in_file) && i < cur_line; i++) 
	    fputs(in_buffer, out_file);  /* write it out to the file */
    }

	/* find the first form link */
    old_link_num = -1;
    link_num = 0;
    while(!links[link_num].type == FORM_LINK_TYPE && link_num < nlinks) 
        link_num++;

	/* there is already a line in the in_buffer */
    /* read the file line by line and change the inits to the cur values */
    do {   /* do-while loop - do until link_num = nlinks or run out of file */

        for(place_ptr=in_buffer; *place_ptr != '\0'; place_ptr++) {

	    /* get the new value for the next INIT */
	    if(old_link_num != link_num) {
               switch(links[link_num].tx) {
	        case BOOLEAN_TYPE:
	            sprintf(new_value,"%s",
			    (links[link_num].cur_value ? "ON" : "OFF"));
	            break;
	        case INT_TYPE:
	            sprintf(new_value,"%d",links[link_num].cur_value);
	            break;
	        case DATE_MONTH_TYPE:
		        /* date month-day-year all form one value */
	            time_st.tm_mon   = links[link_num].cur_value;
		    link_num++;
	            time_st.tm_mday  = links[link_num].cur_value;
		    link_num++;
	            time_st.tm_year  = links[link_num].cur_value - 1900;
	            time_st.tm_hour  = 1;
	            time_st.tm_min   = 0;
	            time_st.tm_sec   = 1;
        
	            sprintf(new_value,"%ld",mktime(&time_st));
	            break;
	        case TIME_HOUR_TYPE:
	            sprintf(new_value,"NOT DONE YET");
	            break;
		case PASSWORD_TYPE:
		    /* the real password data is kept in taddr */
	            sprintf(new_value,links[link_num].taddr);
	            break;
		case STRING_TYPE:
	            sprintf(new_value,"%s",links[link_num].cur_value);
	            break;
	        default:
	            sprintf(new_value,"%d",links[link_num].cur_value);
	            break;
	        } /* end case */
	        old_link_num = link_num;
	    } /* end if */
    
    	
		/* found what may be a form link */
	    if(*place_ptr == delimiter.link && *(place_ptr+1) == '#') {
		
		link_end_ptr = link_start_ptr = place_ptr+2;

		for(; *link_end_ptr != delimiter.link &&
			*link_end_ptr != delimiter.end_link &&
			  *link_end_ptr != '\0'; link_end_ptr++) 
			;  /* null body */	

		if(*link_end_ptr == delimiter.end_link &&
			link_end_ptr - link_start_ptr <= MAXFNAME+MAXTARGET) {
		   /* it is definately a link */

		    /* parse_tag returns the init value and the pointer
		     * of the value in init_ptr
	             * init_length will hold the length of the current
		     * init value
		     */
		    init_length = strlen(parse_tag(link_start_ptr, "INIT", 
								    &init_ptr));

		    if(init_length > 0) {
			/* init exists already in link */
			/* copy the end to temp space */
			strcpy(temp_string, init_ptr+init_length);
			/* overwrite with new info */
			strcpy(init_ptr, new_value);
			/* put old stuff back on */
			strcat(in_buffer, temp_string);
		     } else {
			/* init doesn't exist: create and fill it in */
			/* copy the end to temp space */
			strcpy(temp_string, link_start_ptr);
			/* add the info by overwriting */
			sprintf(link_start_ptr,"INIT=\"%s\" ", new_value);
			/* put the stuff back on the end */
			strcat(in_buffer, temp_string);
		     }  /* end if-else */

		     link_num++;  /* move on to the next link */
		     place_ptr += link_end_ptr - link_start_ptr;
		  }   /* end if */ 
	     }	/* end if */
	}  /* end for */

       /* write the line to the file */
	fputs(in_buffer, out_file);

    } while(link_num < nlinks && fgets(in_buffer,LINESIZE, *in_file));

	/* finish out the rest of the file */
    while(fgets(in_buffer,LINESIZE, *in_file) != NULL) {
	fputs(in_buffer, out_file);
    }

	/* close the in file */
   fclose(*in_file);

   fclose(out_file);

	/* the new file is now the in_file */
   *in_file = fopen(cur_file_name,"r");


}  /* end the program */

